#include "vektor.h"
#include <math.h>

// A = A + B

void ScitajVektory (TVektor *A, TVektor *B)
 {
  A->X += B->X;
  A->Y += B->Y;
  A->Z += B->Z;
 }

// A = A - B;

void OdcitajVektory (TVektor *A, TVektor *B)
 {
  A->X -= B->X;
  A->Y -= B->Y;
  A->Z -= B->Z;
 }

// V --->  |V| = 1

void NormalizujVektor (TVektor *V, TVektor *N)
 {
  float Len = DlzkaVektora (V);
  *N = *V;
  N->X /= Len;
  N->Y /= Len;
  N->Z /= Len;
 }

// C = A x B

void VektorovySucin (TVektor *A, TVektor *B, TVektor *C)
 {
  C->X = A->Y * B->Z - A->Z * B->Y;
  C->Y = A->Z * B->X - A->X * B->Z;
  C->Z = A->X * B->Y - A->Y * B->X;
 }

// A . B

float SkalarnySucin (TVektor *A, TVektor *B)
 {
  return A->X * B->X + A->Y * B->Y + A->Z * B->Z;
 }

// |A|

float DlzkaVektora (TVektor *A)
 {
  return sqrt (A->X*A->X + A->Y*A->Y + A->Z*A->Z);
 }
